# bk1_amazon.rb $Revision: 1.11 $
# Copyright (C) 2004  Michitaka Ohno <elpeo@mars.dti.ne.jp>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

def get_bk1_image( position, isbn, comment )
	h = get_bk1( isbn )

	return isbn if h.length < 2

	if @conf['amazon.imgsize'] && @conf['amazon.imgsize']  != 0 then
		image_url = h['ImageUrlSmall'] || 'http://www.bk1.co.jp/images/bk1/no_img_90.gif'
	else
		image_url = h['ImageUrlLarge'] || 'http://www.bk1.co.jp/images/bk1/no_img_144.gif'
	end
	item_name = comment || h['ProductName']

	r = ""
	r << %Q[<a href="#{h['DetailURL']}">]
	if @mode != 'categoryview' then
		unless /no_img/ =~ image_url && @conf['amazon.nodefault'] then
			r << %Q[<img class="#{position}" src="#{image_url}" alt="#{item_name}">]
		end
	end
	if !@conf['amazon.hidename']  || @conf['amazon.nodefault'] then
		r << item_name if position == "amazon"
	end
	r << %Q[</a>]
end

alias isbn_image_left_orig isbn_image_left

def isbn_image_left( asin, comment = nil )
	return isbn_image_left_orig( asin, comment ) unless /^[0-9-]{9,12}[\d|Xx]$/ =~ asin && @conf['bk1.amazon']
	r = get_bk1_image( "left", asin, comment )
	r == asin ? isbn_image_left_orig( asin, comment ) : r
end

alias isbn_image_right_orig isbn_image_right

def isbn_image_right( asin, comment = nil )
	return isbn_image_right_orig( asin, comment ) unless /^[0-9-]{9,12}[\d|Xx]$/ =~ asin && @conf['bk1.amazon']
	r = get_bk1_image( "right", asin, comment )
	r == asin ? isbn_image_right_orig( asin, comment ) : r
end

alias isbn_image_orig isbn_image

def isbn_image( asin, comment = nil )
	return isbn_image_orig( asin, comment ) unless /^[0-9-]{9,12}[\d|Xx]$/ =~ asin && @conf['bk1.amazon']
	r = get_bk1_image( "amazon", asin, comment )
	r == asin ? isbn_image_orig( asin, comment ) : r
end

alias isbn_orig isbn

def isbn( asin, comment )
	return isbn_orig( asin, comment ) unless /^[0-9-]{9,12}[\d|Xx]$/ =~ asin && @conf['bk1.amazon']
	%Q[<a href="http://breeder.bk1.jp/rd/#{asin}/#{get_bk1_aid}/noentry">#{comment.strip}</a>]
end

def amazon_bk1( isbn, comment = nil )
	r = isbn_image_orig( isbn, comment )
	return get_bk1_image( "amazon", isbn, comment ) if r == isbn
	if /^[0-9-]{9,12}[\d|Xx]$/ =~ isbn then
		h = get_bk1( isbn )
		if @conf['amazon.imgsize'] && @conf['amazon.imgsize']  != 0 then
			image_url = h['ImageUrlSmall'] || 'http://www.bk1.co.jp/images/bk1/no_img_90.gif'
		else
			image_url = h['ImageUrlLarge'] || 'http://www.bk1.co.jp/images/bk1/no_img_144.gif'
		end
		r.sub!( %r|http://[^"]+comingsoon_books\.gif|, image_url ) unless image_url =~ /no_img/
		if h['DetailURL'] then
			r << %Q[<a href="#{h['DetailURL']}">]
			if @conf['bk1.iconsize']==1 then
				r << %Q[<img src="http://www.bk1.co.jp/images/bk1/bk1mini.gif" style="border-width: 0px" alt="bk1">]
			else
				r << %Q[<img src="http://www.bk1.co.jp/images/bk1/bk1m-rogo.gif" style="border-width: 0px" alt="bk1">]
			end
			r << %Q[</a>]
		end
	end
	return r
end

alias bk1_conf_proc_original bk1_conf_proc

def bk1_conf_proc
	if @mode == 'saveconf' then
		@conf['bk1.amazon'] = (@cgi.params['bk1.amazon'][0] == 'true')
		@conf['bk1.iconsize'] = @cgi.params['bk1.iconsize'][0].to_i
	end
	r = bk1_conf_proc_original
	r << <<-HTML
	<h3>#{@bk1_amazon_label_amazon}</h3>
	<p><select name="bk1.amazon">
	<option value="true"#{" selected"if @conf['bk1.amazon']}>#{@bk1_amazon_label_replace}</option>
	<option value="false"#{" selected" unless @conf['bk1.amazon']}>#{@bk1_amazon_label_notreplace}</option>
	</select></p>
	<h3>#{@bk1_amazon_label_iconsize}</h3>
	<p><select name="bk1.iconsize">
	<option value="0"#{" selected" if @conf['bk1.iconsize']==0}>#{@bk1_amazon_label_large}</option>
	<option value="1"#{" selected" if @conf['bk1.iconsize']==1}>#{@bk1_amazon_label_small}</option>
	</select></p>
	HTML
end

#include "ja/bk1_amazon.rb"
